Index: callerid.c
===================================================================
RCS file: /usr/cvsroot/asterisk/callerid.c,v
retrieving revision 1.13
diff -u -r1.13 callerid.c
--- callerid.c	9 Nov 2003 18:46:52 -0000	1.13
+++ callerid.c	9 Mar 2004 19:41:36 -0000
@@ -48,8 +48,10 @@
 float sasdr, sasdi;
 float casdr1, casdi1, casdr2, casdi2;
 
-#define CALLERID_SPACE	2200.0		/* 2200 hz for "0" */
-#define CALLERID_MARK	1200.0		/* 1200 hz for "1" */
+//#define CALLERID_SPACE	2200.0	/* 2200 hz for "0" */
+//#define CALLERID_MARK	1200.0		/* 1200 hz for "1" */
+#define CALLERID_SPACE	2100.0		// CCITT V23
+#define CALLERID_MARK	1300.0		// CCITT V23
 #define SAS_FREQ		 440.0
 #define CAS_FREQ1		2130.0
 #define CAS_FREQ2		2750.0
Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.180
diff -u -r1.180 chan_zap.c
--- channels/chan_zap.c	3 Mar 2004 03:54:25 -0000	1.180
+++ channels/chan_zap.c	9 Mar 2004 19:43:05 -0000
@@ -530,7 +530,13 @@
 	{ { 125, 125, 2000, 4000 } },			/* Quick chirp followed by normal ring */
 	{ { 250, 250, 500, 1000, 250, 250, 500, 4000 } }, /* British style ring */
 	{ { 125, 125, 125, 125, 125, 4000 } },	/* Three short bursts */
-	{ { 1000, 500, 2500, 5000 } },	/* Long ring */
+	//{ { 1000, 500, 2500, 5000 } },	/* Long ring */
+	{ { 250, 3000, 1000, 4000, 1000, 4000, 1000, 4000, 1000, 4000, 1000, 4000, 1000, 4000, 1000, 4000 } },	// Test ring for callerid posterior to a short ring pattern 
+	   /* The short ring is called Ring Pulse Alert Signal (RP-AS) . From ETSI EN 300 659-1 V1.3.1 (2001) :
+	      200ms < RP-AS duration < 300ms
+	      500ms < RP-AS to FSK < 800ms
+	      200ms < FSK to FSK < 500ms
+           */												   
 };
 
 int receivedRingT; /* Used to find out what ringtone we are on */
@@ -543,7 +549,8 @@
 	2,										/* Right after first long ring */
 	4,										/* Right after long part */
 	3,										/* After third chirp */
-	2,										/* Second spell */
+	//2,										/* Second spell */
+	1,										// Test for callerid posterior to a short ring pattern
 };
 
 #define ISTRUNK(p) ((p->sig == SIG_FXSLS) || (p->sig == SIG_FXSKS) || \
@@ -3426,6 +3433,10 @@
 
 struct ast_frame  *zt_read(struct ast_channel *ast)
 {
+  static int cpt=0;  // counter used as a timer
+  if(ast->rings != 1) cpt=0;  // only counts between the first and the second ring
+  else cpt++;  
+
 	struct zt_pvt *p = ast->pvt->pvt;
 	int res;
 	int index;
@@ -3612,6 +3623,7 @@
 
 	/* Handle CallerID Transmission */
 	if ((p->owner == ast) && p->cidspill &&((ast->_state == AST_STATE_UP) || (ast->rings == p->cidrings))) {
+	  if(cpt>10)  // should delay the CID so that it starts around  600 ms after the first ring. A required "RP-AS to FSK" timing.
 		send_callerid(p);
 	}
 
